<script setup>
import { useForm } from "@inertiajs/vue3";

const props = defineProps({
    filters: Object,
    searchRoute: String,
});

const filterForm = useForm({
    searchItems: props.filters.searchItems ?? null,
});

const filter = (searchRoute) => {
    filterForm.get(route(searchRoute), {
        preserveState: true,
        preserveScroll: true,
    });
};

const clear = () => {
    filterForm.searchItems = null;
    filter();
};
</script>

<template>
    <form @submit.prevent="filter(props.searchRoute)">
        <div class="p-4 bg-white dark:bg-gray-900 flex">
            <label class="sr-only" for="table-search">Search </label>
            <div class="relative mt-1">
                <div
                    class="absolute inset-y-0 rtl:inset-r-0 start-0 flex items-center ps-3 pointer-events-none"
                >
                    <svg
                        aria-hidden="true"
                        class="w-4 h-4 text-gray-500 dark:text-gray-400"
                        fill="none"
                        viewBox="0 0 20 20"
                        xmlns="http://www.w3.org/2000/svg"
                    >
                        <path
                            d="m19 19-4-4m0-7A7 7 0 1 1 1 8a7 7 0 0 1 14 0Z"
                            stroke="currentColor"
                            stroke-linecap="round"
                            stroke-linejoin="round"
                            stroke-width="2"
                        />
                    </svg>
                </div>
                <input
                    v-model="filterForm.searchItems"
                    class="block pt-2 ps-10 mr-2 text-sm text-gray-900 border border-gray-300 rounded-lg w-80 bg-gray-50 focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500"
                    placeholder="Type here ..."
                    type="text"
                />
            </div>
            <button
                class="inline-flex items-center px-4 py-2 mt-1 h-8.5 bg-gray-800 dark:bg-gray-200 border border-transparent rounded-md font-semibold text-xs text-white dark:text-gray-800 uppercase tracking-widest hover:bg-gray-700 dark:hover:bg-white focus:bg-gray-700 dark:focus:bg-white active:bg-gray-900 dark:active:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 dark:focus:ring-offset-gray-800 transition ease-in-out duration-150"
                type="submit"
            >
                Search
            </button>
            <button
                class="inline-flex items-center px-4 py-2 mt-1 h-8.5 border border-transparent rounded-md font-semibold text-xs text-gray-800 hover:text-gray-500 dark:text-white uppercase tracking-widest dark:hover:bg-white dark:active:bg-gray-300 transition ease-in-out duration-150"
                type="reset"
                @click="clear"
            >
                Clear
            </button>
        </div>
    </form>
</template>
